package pages
{
	import flash.display.GradientType;
	import flash.geom.Matrix;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import jp.progression.casts.CastButton;
	import jp.progression.casts.CastSprite;
	import jp.progression.commands.display.AddChild;
	import jp.progression.commands.display.RemoveAllChildren;
	import jp.progression.scenes.SceneId;
	
	public class IndexPage extends CastSprite
	{
		private var _text:TextField;
		private var _btn:CastButton;
		public function IndexPage(initObject:Object=null)
		{
			super(initObject);
		}


		protected override function atCastAdded():void
		{
			var mat:Matrix = new Matrix();
			mat.createGradientBox(stage.stageWidth, stage.stageHeight, 0, 0, 0);
			_btn = new CastButton();
			_btn.graphics.beginGradientFill(
				GradientType.RADIAL,
				[0xCCCCCC, 0xCCCCCC],
				[0.1, 1],
				[0, 255],
				mat
				);
			//_btn.graphics.endFill();
			_btn.buttonMode = true;
			_btn.sceneId = new SceneId("/index/top");
			_btn.graphics.drawRect(0, 0, stage.stageWidth, stage.stageHeight);
			var textFormat:TextFormat = new TextFormat();
			textFormat.align = TextFormatAlign.CENTER;
			textFormat.bold = true;
			textFormat.size = 14;
			_text = new TextField();
			_text.defaultTextFormat = textFormat;
			_text.text = "WEBカメラを接続して、画面クリックでスタートします。";
			_text.autoSize = TextFieldAutoSize.CENTER;
			_text.type = TextFieldType.DYNAMIC;
			_text.selectable = false;
			_text.x = (stage.stageWidth - _text.width) * 0.5;
			_text.y = (stage.stageHeight - _text.height) * 0.5;
			addCommand(
				new AddChild(this, _btn),
				new AddChild(this, _text)
			);
		}

		protected override function atCastRemoved():void
		{
			addCommand(
				new RemoveAllChildren(this),
				function():void{
					_btn = null;
					_text = null;
				}
			);
		}

	}
}