package scenes {
	import flash.display.Sprite;
	import flash.media.Video;
	
	import jp.progression.casts.*;
	import jp.progression.commands.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.managers.*;
	import jp.progression.commands.media.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.executors.*;
	import jp.progression.scenes.*;
	
	import pages.IndexPage;
	
	import tools.VideocameraTool;
	
	/**
	 * ...
	 * @author ...
	 */
	public class IndexScene extends SceneObject {
		
		private var _page:IndexPage;
		private var _video:Sprite;
		/**
		 * 新しい IndexScene インスタンスを作成します。
		 */
		public function IndexScene() {
			// シーンタイトルを設定します。
			title = "virtual_ar";
		}
		
		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは子階層だった場合に、階層が変更された直後に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneLoad():void {
			addCommand(
				function():void{
					addScene(new TopScene);
				}
			);
		}
		
		/**
		 * シーンオブジェクト自身が目的地だった場合に、到達した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneInit():void {
			_page = new IndexPage();
			_video = new Sprite();
			if(VideocameraTool.useCamera()){
				var tool:VideocameraTool = VideocameraTool.getInstance();
				var video:Video = tool.video;
				addCommand(
					new AddChildAt(container, _page, 1)
				);
				if(tool.test){
					_video.addChild(video);
					_video.scaleX = _video.scaleY = VideocameraTool.WIPE_SCALE;
					_video.scaleX *= -1;
					_video.x = _video.width;
					addCommand(
						new AddChild(container, _video, 100)
					);
				}
			}
		}
		
		/**
		 * シーンオブジェクト自身が出発地だった場合に、移動を開始した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneGoto():void {
			addCommand(
				new RemoveChild(container, _page),
				//new RemoveChild(container, _video),
				function():void{
					_page = null;
					//_video = null;
				}
			);
		}
		
		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは親階層だった場合に、階層が変更される直前に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneUnload():void {
			addCommand(
			);
		}
	}
}
