package tools
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.geom.Matrix;
	import flash.geom.Rectangle;
	import flash.media.Video;
	import flash.utils.Timer;
	import flash.utils.getTimer;
	
	import jp.maaash.ObjectDetection.ObjectDetector;
	import jp.maaash.ObjectDetection.ObjectDetectorEvent;
	import jp.maaash.ObjectDetection.ObjectDetectorOptions;
	import jp.progression.casts.CastSprite;
	import jp.progression.commands.display.RemoveAllChildren;
	
	public class Detector extends CastSprite
	{
		public static const RECTANGLE_UPDATE:String = "rectangle_update";
		private var _detector:ObjectDetector;
		private var _timer:Timer;
		private var _delay:Number;
		
		private var _prevTime:Number;
		private var _rect:Rectangle;
		private var _tool:VideocameraTool;
		private var _bitmapData:BitmapData;
		private var _mat:Matrix;
		private var _scale:Number;
		
		public function Detector(initObject:Object=null)
		{
			super(initObject);
		}
		
		private function _onTimerHandler(event:TimerEvent):void
		{
			_prevTime = getTimer();
			var video:Video = _tool.video;
			_bitmapData.draw(video, _mat);
			_detector.detect(new Bitmap(_bitmapData));
		}
		
		private function _onDetectionCompleteHandler(event:ObjectDetectorEvent):void
		{
			if(event.rects.length > 0){
				_rect = event.rects[0] as Rectangle;
			}
			//_timer.delay = (getTimer() - _prevTime);
			_timer.reset();
			_timer.start();
			dispatchEvent(new Event(RECTANGLE_UPDATE));
			
			if(_tool.test){
				_drawRect();
			}
			//trace(getTimer() - _prevTime)
			
		}
		
		private function _drawRect():void
		{
			graphics.clear();
			if(!(!_rect)){
				var w:Number = _rect.width * _scale;
				graphics.lineStyle(0, 0xFFFF00);
				graphics.drawRect((_rect.x * -_scale) + ((_tool.video.width * _scale) * 0.5) - w,
					_rect.y * _scale,
					w,
					_rect.height * _scale);
			}
		}
		
		protected override function atCastAdded():void
		{
			_tool = VideocameraTool.getInstance();
			_scale = VideocameraTool.WIPE_SCALE / VideocameraTool.VIDEO_SCALE;
			_mat = new Matrix();
			_mat.scale(VideocameraTool.VIDEO_SCALE, VideocameraTool.VIDEO_SCALE);
			_bitmapData = new BitmapData(_tool.video.width * VideocameraTool.VIDEO_SCALE, _tool.video.height * VideocameraTool.VIDEO_SCALE, false);
			_detector = new ObjectDetector();
			var options:ObjectDetectorOptions = new ObjectDetectorOptions();
			options.min_size = 50;
			//options.search_mode = ObjectDetectorOptions.SEARCH_MODE_SOLO;
			/*
			options.startx = ObjectDetectorOptions.INVALID_POS;
			options.starty = ObjectDetectorOptions.INVALID_POS;
			options.endx = ObjectDetectorOptions.INVALID_POS;
			options.endy = ObjectDetectorOptions.INVALID_POS;
			*/
			_detector.options = options;
			_detector.addEventListener(ObjectDetectorEvent.DETECTION_COMPLETE, _onDetectionCompleteHandler);
			_detector.loadHaarCascades("http://utweb.jp/samples/kao2/face.zip");
			
			_delay = 10;
			_timer = new Timer(_delay, 1);
			_timer.addEventListener(TimerEvent.TIMER, _onTimerHandler);
			addCommand(
				function():void{
					_prevTime = getTimer();
					_timer.start();
				}
			);
		}
		
		protected override function atCastRemoved():void
		{
			addCommand(
				new RemoveAllChildren(this),
				function():void{
					_bitmapData.dispose();
					_bitmapData = null;
					_timer.removeEventListener(TimerEvent.TIMER, _onTimerHandler);
					_timer.stop();
					_timer = null;
					_detector.removeEventListener(ObjectDetectorEvent.DETECTION_COMPLETE, _onDetectionCompleteHandler);
					_detector = null;
					_tool = null;
					_mat = null;
				}
			);
		}

		public function get rect():Rectangle
		{
			return _rect;
		}

	}
}